;-------------------------------------------------------------------------------
; Aktion mit den Entities
For AA_e.AA_entity = Each AA_entity

	If AA_e\state = True
	
		Select AA_e\entity_type
		
			Case AA_TRIGGER
				
				If RectsOverlap(MouseX(),MouseY(),1,1,AA_e\x,AA_e\y,AA_e\width,AA_e\height)
				
					AA_e\output_type = AA_COND_Touch
					
				EndIf
		
				
				
			Case AA_GAME_MESSAGE
				
				Color 255,255,255	
				Text AA_e\x,AA_e\y,AA_e\message$
				
				
				
			Case AA_BUTTON
				
				If MouseDown(1)
				
					If RectsOverlap(MouseX(),MouseY(),1,1,AA_e\x,AA_e\y,AA_e\width,AA_e\height)
					
						AA_e\output_type = AA_COND_Use
						If AA_e\u\deactivate = True  AA_e\state = False
						
					EndIf
				
				EndIf
				
				
			Case AA_TRAIN
			
				Text AA_e\x+2,AA_e\y+20,AA_e\m\target$
				
					
					For f.AA_entity = Each AA_entity
					
						If f\name$ = AA_e\m\target$
						
							AA_e\m\xTarget = f\x
							AA_e\m\yTarget = f\y
							
							If (AA_e\x = AA_e\m\xTarget)
								If (AA_e\y = AA_e\m\yTarget)
								
									AA_e\m\target$ = f\message$
									
								EndIf
							EndIf
						
						EndIf
						
					Next
					
				; Bewegung, wenn Koordinaten nicht denen des Ziel-Entitys entsprechen
					If (AA_e\x < AA_e\m\xTarget)
						AA_e\x = AA_e\x + AA_e\m\xSpeed
					ElseIf (AA_e\x > AA_e\m\xTarget)
						AA_e\x = AA_e\x - AA_e\m\xSpeed
					EndIf
					If (AA_e\y < AA_e\m\yTarget)
						AA_e\y = AA_e\y + AA_e\m\ySpeed
					ElseIf (AA_e\y > AA_e\m\yTarget)
						AA_e\y = AA_e\y - AA_e\m\ySpeed
					EndIf
					
				; ansonsten Meldung
					If AA_e\x = AA_e\m\xTarget
						If AA_e\y = AA_e\m\yTarget
							
							AA_e\output_type = AA_COND_ReachTarget
							
						EndIf
					EndIf


			Case AA_TIMER
			
				; berprft die Startzeit mit der aktuellen Zeit und gibt Meldung, wenn
				; max_value berschritten wurde
				If MilliSecs() - AA_e\c\value > AA_e\c\max_value
				
					AA_e\output_type = AA_COND_ReachValue
					
					; ist reset wahr, wird der Zhler neu gesetzt
					If AA_e\c\reset = True  AA_e\c\value = MilliSecs()
					
				EndIf
				
				
			Case AA_COUNTER
			
				If AA_e\c\value = AA_e\c\max_value
				
					AA_e\output_type = AA_COND_ReachValue
					
					If AA_e\c\reset = True  AA_e\c\value = 0
				
				EndIf
				
				Text AA_e\x,AA_e\y+16,AA_e\c\value + "/" + AA_e\c\max_value
		
	End Select ;Select AA_e\entity_type
	
	EndIf

	;AA_outputs aktivieren
	For AA_out.AA_output = Each AA_output
	
		If AA_out\source$ = AA_e\name$
		
			If AA_out\condition$ = AA_e\output_type
			
				AA_out\state = True
				AA_e\output_type = 0
				
			EndIf
			
		EndIf
		
	Next
	
	Select AA_e\entity_type
	
		Case AA_TRIGGER  Color 127,127,0
		Case AA_GAME_MESSAGE  Color 255,255,255
		Case AA_BUTTON  Color 255,0,0
		Case AA_TRAIN  Color 127,127,127
		Case AA_PATH  Color 200,0,200
		Case AA_TIMER Color 0,100,100
		Case AA_COUNTER Color 127,0,127
		
	End Select
	
	If AA_e\visible = True
		Rect AA_e\x, AA_e\y, AA_e\width, AA_e\height, 0
		Text AA_e\x+2, AA_e\y+2, AA_e\state+")"+AA_e\name$
	EndIf

;-------------------------------------------------------------------------------

		;+++++++++++++++++++++++++++
		; Entities zeichnen
		; Sollte man sich entscheiden, den Type "AA_entity" um die Komponente "image" zu erweitern...
		Select AA_e\entity_type
		
			Case AA_TRIGGER  Color 127,127,0
			Case AA_GAME_MESSAGE  Color 255,255,255
			Case AA_BUTTON  Color 255,0,0
			Case AA_TRAIN  Color 127,127,127
			Case AA_PATH  Color 200,0,200
			Case AA_TIMER Color 0,100,100
			Case AA_COUNTER Color 127,0,127
			
		End Select
			
		; ... sieht diese Zeile so aus: "If e\visible = True  DrawImage e\image, e\x, e\y" [, e\frame]
		If AA_e\visible = True
			Rect AA_e\x, AA_e\y, AA_e\width, AA_e\height, 0
			;Text AA_e\x+2, AA_e\y+2, AA_e\state+")"+AA_e\name$
		EndIf
		;+++++++++++++++++++++++++++
Next; For AA_e.AA_entity = Each AA_entity

;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Realisierung der Outputs
For AA_out.AA_output = Each AA_output

	If AA_out\state = True
	
		For AA_e.AA_entity = Each AA_entity
		
			If AA_out\target$ = AA_e\name$; Ziel entspricht AA_entity-Name
			
				Select AA_out\order
				
					Case AA_ORDER_Activate
						AA_e\state = True
						If AA_e\entity_type = AA_TIMER  AA_e\c\value = MilliSecs()
					
					Case AA_ORDER_Deactivate
						AA_e\state = False
					
					Case AA_ORDER_Delete
						AA_e\state = AA_USED
						
					Case AA_ORDER_SetMessage
						AA_e\message$ = AA_out\message$
						
					Case AA_ORDER_SetTarget
						AA_e\m\target$ = AA_out\message$
						
					Case AA_ORDER_IncreaseValue
						AA_e\c\value = AA_e\c\value + 1
											
				End Select

			EndIf

			If AA_e\state = AA_USED  Delete AA_e.AA_entity

		Next
		
		If AA_out\deactivate = True  AA_out\state = False
		If AA_out\stay = False  AA_out\state = AA_USED
		
	EndIf
	
	If AA_out\state = AA_USED  Delete AA_out.AA_output

Next
;-------------------------------------------------------------------------------

;---------------------------------------------------------------------------------------------------