Type AA_entity
	Field entity_type
	Field name$
	Field x%,y%,height%,width%
	Field state%				; Zustand (aktiv / inaktiv)
	Field visible%				; Entity ist sichtbar (zu Testzwecken)
	Field message$				; Text der angezeigt wird oder Nachricht, die mitgegeben wird
	Field output_type			; Typ der Rckgabe, z.B. "Touch" oder "Use"
	Field m.AA_mobile			; bei beweglichen Entities
	Field u.AA_usable			; bei benutzbaren Entities
	Field c.AA_count			; bei Entities, die etwas zhlen (z.B. Zeit, Aktionen)
	;Field image
	;Field sound
End Type

;-------------------------------------------------------------------------------
Type AA_mobile
	Field xSpeed, ySpeed		; Geschwindigkeit auf den Achsen
	Field target$				; Name des Ziel-Entitys (gewhnlich ein "Path")
	Field xTarget, yTarget		; Koordinaten des Ziels
End Type


Type AA_usable
;	Field sound					; Sound, der bei Benutzung abgespielt wird
	Field deactivate			; Entity wird nach Benutzung deaktiviert
End Type


Type AA_count
	Field value					; momentaner Wert
	Field max_value				; Maximalwert, bei dem Rckmeldung gegeben wird
	Field reset					; setzt value auf seinen Startwert, wenn max_value erreicht wurde
End Type


;-------------------------------------------------------------------------------
Type AA_output
	Field state%				; Zustand
	Field stay%					; lscht Output nach Benutzung, wenn 0
	Field deactivate			; deaktiviert den Output nach Benutzung, lscht ihn aber nicht
	
; wichtig fr das Quell-Entity
	Field source$
	Field condition				; Bedingung fr Output, Auslseaktion

; wichtig fr das Ziel-Entity
	Field order					; Befehl, der ausgefhrt werden soll
	Field target$				; Output-Ziel
	Field message$				; kann ein neues Ziel sein etc.
	
End Type